'#########################################################################
'#  MSMD_BAS_TEST                                                        #
'#  Prosty program demonstracyjno-testowy                                #
'#  dla sterownika silnikw krokowych MSMD_0v11                          #
'#  Mikrokontroler: MEGA8, MEGA168, zewntrzny kwarc 12MHz               #
'#  Wersja: 0v11                                                         #
'#  Plik rdowy: MSMD_Bas_Test_0v11.bas                                #
'#  Data ostatniej modyfikacji: 03.04.2013                               #
'#  Autor: c4v2 Cyprian Kamil Kowalski                                   #
'#########################################################################
'|                            !!! UWAGA !!!                              |
'+-----------------------------------------------------------------------+
'| Zwierajc zwor piny 1 i 2 VREF, zcza grzebieniowego JP3            |
'| wymusi "Wewntrzn regulacj prdu"                                  |
'| Konfiguracja pozostaych zwr sterownika MSMD jest dowolna            |
'+-----------------------------------------------------------------------+
'| Parametry transmisji szeregowej: 9600,8,n,1                           |
'| Wszystkie niej wymienione polecenia parametryczne                    |
'|   podane bez parametru zwracaj status polecenia                      |
'+-----------------------------------------------------------------------+
'| Polecenia i moliwe parametry testera z programu terminalowego        |
'+------+--------+-------------------------------------------------------+
'| HELP |   -    | Wywietlenie listy polece sterujcych                |
'| ?    |   -    | Wywietlanie statusu testera                          |
'| CSM  | ON/OFF | Tryb prdkoci nie/zalenie od rozdzielczoci         |
'| RUN  |        | Wczenie obrotw                                     |
'| STOP |        | Wyczenie obrotw                                    |
'| TEST |   -    | Wczenie sekwencyjnego trybu testowego...            |
'|               |   Zmiana promptu na czas testu z ">" na ":"           |
'|               |   Odbir znaku CR powoduje przejcie                  |
'|               |   do nastpnego "kroku" sekwencji testowej, wyjcie   |
'|               |   z trybu po wykonaniu caej sekwencji                |
'+------+--------+-------------------------------------------------------+
'| Polecenia i moliwe parametry dla sterownika z programu terminalowego |
'+------+-------------+--------------------------------------------------+
'| RST  |    -        | Zerowanie sterownika                             |
'| SLP  | ON/OFF      | Tryb oszczdzania energii                        |
'| ENB  | ON/OFF      | Praca mostkw mocy                               |
'| DIR  | CW/CCW      | Kierunek obrotw silnika                         |
'| RES  | FS/HS/QS/ES | Rozdzielczo: 1/1, 1/2, 1/4, 1/8 kroku          |
'| BST  | ON/OFF      | Prd roboczy, trzymania                          |
'+------+-------------+--------------------------------------------------+
'| Przypisania pinw:                                                    |
'+------+-----+--------------+-------------------------------------------+
'| PIN  | I/O | I/O  MSMD    | Peniona funkcja                          |
'+------+-----+--------------+-------------------------------------------+
'| PB.0 | OUT | [ 2] STEP    | Impulsy zegarowe krokw                   |
'| PB.1 | OUT |  -   -       | Impulsy zegarowe OC1A                     |
'| PB.2 | OUT | [ 1] !RESET  | Zerowanie sterownika                      |
'| PB.3 | OUT | [ 4] !ENABLE | Praca mostkw mocy                        |
'| PB.4 | OUT | [ 8] !SLEEP  | Tryb oszczdzania energii                 |
'| PB.5 | OUT | [ 7] BOOST   | Prd roboczy, trzymania                   |
'+------+-----+--------------+-------------------------------------------+
'| PD.0 | RXD |  -   -       | Nadajnik konwertera USART <-> RS232       |
'| PD.1 | TXD |  -   -       | Odbiornik konwertera USART <-> RS232      |
'|                           |   MAX232 lub FT232 dla wirtualnego portu  |
'| PD.2 | IN  | [10] !HOME   | Synchronizacja z sekwencerem (INT0)       |
'| PD.3 | OUT | [ 5] MS1     | Rozdzielczo kroku                       |
'| PD.4 | OUT | [ 3] MS2     | Rozdzielczo kroku                       |
'| PD.5 | OUT | [ 6] DIR     | Kierunek obrotw silnika                  |
'+------+-----+--------------+-------------------------------------------+
'| PC.2 | ADC |  -   -       | Suwak potencjometru (do 10k) zadajcego   |
'|                           |   prdko obrotow, 0..Vcc uP MEGA8)     |
'| PC.3 | OUT |  -   -       | [!TEST] sekwencyjny tryb testowy          |
'| PC.4 | OUT |  -   -       | [!CSM] tryb prdkoci zaleny/niezaleny  |
'|                           |   od rozdzielczoci krokowej              |
'| PC.5 | OUT |  -   -       | [!RUN] Wczenie/wyczenie obrotw       |
'+------+-----+--------------+-------------------------------------------+

'----------------------------------------------------------------------------------------
'Dyrektywy kompilatora
'----------------------------------------------------------------------------------------
'$sim                                   'Symulacja programowa
$regfile = "m8def.dat"                  'Dyrektywa pliku z definicjami rejestrw mikroprocesora.
'$regfile = "m168def.dat"                'Dyrektywa pliku z definicjami rejestrw mikroprocesora.
$crystal = 12000000                     'Czstotliwo zegara mikroprocesora.
$baud = 9600                            'Prdko transmisji szeregowej

'----------------------------------------------------------------------------------------
'Konfiguracja
'----------------------------------------------------------------------------------------
Config Timer1 = Timer , Prescale = 64 , Compare A = Toggle , Clear Timer = 1       'Impuls co 1/8000000*64=8us
Config Int0 = Falling                   'Reakcja przerwania zewntrznego na zbocze opadajce
Config Adc = Single , Prescaler = Auto , Reference = Avcc       'Konfiguracja przetwornika AD
Config Portb.0 = Output                 '[ STEP    ] Wyjcie impulsw zegarowych krokw silnika
Config Portb.1 = Output                 'Wyjcie impulsw zegarowych (OC1A) np. do podgldu oscyloskopem...
Config Portb.2 = Output                 '[ !RESET  ][RST] Wyjcie zerujce sterownik silnika
Config Portb.3 = Output                 '[ !ENABLE ][ENB] Wyjcie wczajce mostki mocy sterownika silnika
Config Portb.4 = Output                 '[ !SLEEP  ][SLP] Wyjcie wczajce tryb oszczdzanie energii sterownika
Config Portb.5 = Output                 '[ BOOST   ][BST] Wyjcie przeczajce prd roboczy/trzymania silnika
Config Portd.2 = Input                  '[ HOME    ] Wejcie synchronizujce (INT0)
Config Portd.3 = Output                 '[ MS1     ][RES] Wyjcie programujce rozdzielczo kroku silnika
Config Portd.4 = Output                 '[ MS2     ][RES] Wyjcie programujce rozdzielczo kroku silnika
Config Portd.5 = Output                 '[ DIR     ][DIR] Wyjcie programujce kierunek obrotw silnika
Config Portc.3 = Output                 '[TEST] Wczenie sekwencyjnego testu demonstracyjnego
Config Portc.4 = Output                 '[CSM] tryb prdkoci zaleny/niezaleny od rozdzielczoci krokowej
Config Portc.5 = Output                 '[RUN] Wczenie/wyczenie obrotw

'----------------------------------------------------------------------------------------
'Deklaracje procedur
'----------------------------------------------------------------------------------------
On Compare1a Step_sequnce               'Obsugi przerwania od porwnania zawartoci licznika z rejestrem.
On Int0 Home_synhro                     'Obsugi przerwania zewntrznego
Declare Sub Parse_order                 'Parsowanie polece, parametrw i zamiana ich na wartoci numeryczne
Declare Sub Single_cmd                  'Wykonujcej polecenia bez-parametryczne
Declare Sub Demo_test                   'Wykonujcej test sekwencyjny
Declare Sub Set_parameter               'Interpretacja otrzymanego parametru polecenia
Declare Sub Print_help                  'Wysyajcej tekst pomocy
Declare Sub Print_status                'Wysyajcej status urzdzenia

'----------------------------------------------------------------------------------------
'Deklaracje staychych
'----------------------------------------------------------------------------------------
Const Vprog = "MSMD_BAS_TEST_0v11"      'Wersja programu
Const Cmderr = "invalid command"        'Bd polecenia
Const Prmerr = "invalid parameter"      'Bd parametru
Const Prmt = &H3E                       'Domylny znak zachty ">"
Const Prmttst = &H3A                    'Znak zachty w trybie test ":"

'----------------------------------------------------------------------------------------
'Deklaracje zmiennych
'----------------------------------------------------------------------------------------
Dim Clk As Byte                         'Licznik stanu sekwencji
Dim Tmp As Byte                         'Zmienna tymczasowa uywana w przerwaniu OC1A
Dim Div As Byte                         'Dzielnik sekwencji zalenie od wybranej rozdzielczoci krokowej
Dim Chprm As Byte                       'Zezwolenie na zmian rozdzielczoci i kierunku obrotw
Dim Ctrlstep As Byte                    'Ustawienia rozdzielczoci kroku i kierunku, interpretowana w przerwaniu OC1A
'+-----+-----+-----+-----+-----+-----+-----+-----+---------------+
'|  7  |  6  |  5  |  4  |  3  |  2  |  1  |  0  | Rozdzielczo |
'+-----+-----+-----+-----+-----+-----+-----+-----+ kroku:        |
'|  -  | DIR | MS1 | MS2 |    MODULO DIVINDER    |               |
'|     |     |  L  |  L  |  H  |  L  |  L  |  L  | 1/1           |
'|     |     |  H  |  L  |  L  |  H  |  L  |  L  | 1/2           |
'|     |     |  L  |  H  |  L  |  L  |  H  |  L  | 1/4           |
'|     |     |  H  |  H  |  L  |  L  |  L  |  H  | 1/8           |
'|     |     +-----+-----+-----+-----+-----+-----+---------------+
'|     |  H  | Kierunek obrotw: CCW                             |
'|     |  L  |                   CW                              |
'+-----+-----+---------------------------------------------------+
Dim Tmp0 As Byte                        'Tymczasowa dla licznikw w ptlach i oblicze
Dim Prmstat As Byte                     'Dla wczania, wyczania i aktualnego stanu polecenia (statusu)
Dim Order As Byte                       'Warto numeryczna polecenia do wykonania
Dim Param As Byte                       'Warto numeryczna parametru polecenia do wykonania
Dim Index As Byte                       'Indeks aktualnego stanu polecenia (statusu)
Dim Stptst As Byte                      'Aktualny "krok" sekwencji w trybie [TEST]
Dim Prompt As Byte                      'Aktualny znak zachty
Dim Valadc As Word                      'Warto opnienia dla OC1A z przetwornika AD
Dim Tstdel As Word                      'Warto opnienia co ile ma si wykonywa obsuga przerwania OC1A
Dim Stmp As String * 15                 'Tymczasowa zmienna acuchowa
Dim Cmd As String * 10                  'Polecenie odbierane z USART
Dim Prm As String * 5                   'Parametr polecenia odbierany z USART

'----------------------------------------------------------------------------------------
'Program gwny
'----------------------------------------------------------------------------------------
Set Portb.3                             '
Set Portc.3                             'MODE tryb prdkoci zaleny/niezaleny od rozdzielczoci krokowej
Set Portc.4                             'Obroty wyczne [RUN] H
Set Portc.5                             'Tryb testu wyczany [TEST] H
Set Portd.2                             'Podcignicie wejcie synchronizujcego HOME (INT0)
'Jeeli wymagany jest odczyt sprztowej (zwory JP2, JP5 musz by skonfigurowane) konfiguracji rozdzielczoci kroku ponisze linijki odkomentowa:
'Config Portd.3 = Input                  '[ MS1     ][RES] Wejcie czytajce rozdzielczo kroku silnika ustawion sprzetowo
'Config Portd.4 = Input                  '[ MS2     ][RES] Wejcie czytajce rozdzielczo kroku silnika ustawion sprzetowo
'Ctrlstep.5 = Pind.3                     'Odczyt sprzetowo ustawionego bitu MS1 rozdzielczo kroku silnika
'Ctrlstep.4 = Pind.4                     'Odczyt sprzetowo ustawionego bitu MS2 rozdzielczo kroku silnika
'Select Case Ctrlstep                    'W zalenoci od ustawwionej sprztowo rozdzielczoci kroku przypisanie wartoci startowych
'  Case &H00 : Ctrlstep = &H08           'Startowa rozdzielczo kroku 1/1 oraz kierunek ustawny na [CW]
'             Div = &H08                 'Startowa rozdzielczo kroku 1/1 [FS]
'  Case &H20 : Ctrlstep = &H24           'Startowa rozdzielczo kroku 1/2 oraz kierunek ustawny na [CW]
'             Div = &H04                 'Startowa rozdzielczo kroku 1/2 [HS]
'  Case &H10 : Ctrlstep = &H12           'Startowa rozdzielczo kroku 1/4 oraz kierunek ustawny na [CW]
'             Div = &H02                 'Startowa rozdzielczo kroku 1/4 [QS]
'  Case &H30 : Ctrlstep = &H31           'Startowa rozdzielczo kroku 1/8 oraz kierunek ustawny na [CW]
'             Div = &H01                 'Startowa rozdzielczo kroku 1/8 [ES]
'End Select
'Config Portd.3 = Output                 '[ MS1     ][RES] Wyjcie programujce rozdzielczo kroku silnika
'Config Portd.4 = Output                 '[ MS2     ][RES] Wyjcie programujce rozdzielczo kroku silnika
'Jeeli wymagany jest odczyt sprztowej (zwory JP2, JP5 musz by skonfigurowane) konfiguracji rozdzielczoci kroku ponisze dwie linijki zakomentowa:
Ctrlstep = &B00001000                   'Startowa rozdzielczo kroku 1/1 oraz kierunek ustawny na [CW]
Div = &H08                              'Startowa rozdzielczo kroku 1/1 [FS]

Prompt = Prmt                           'Domylny prompt ">"
Enable Interrupts                       'Wczenie globalne systemu przerwa
Enable Int0                             'Wczenie przerwania zewntrznego
Start Adc                               'Wczenie przetwornika AD
Call Print_help                         'HELP wywietlenie tekstu pomocy
Do                                      'Pocztek ptli gwnej
  Set Portb.2                           'Ustawienie wyjcia restart w stan wysoki
  Stmp = ""                             'Czyszczenie tymczasowej zmiennej acuchowej
  Prm = ""                              'Czyszczenie zmiennej acuchowej parametru polecenia
  Print Chr(&H10) ; Chr(&H07) ; Chr(prompt) ;       'Wysanie znaku zachty
  Do                                    'Ptla "kompletujca" polecenie z odebranych znakw
    Do                                  'Oczekiwanie na pojawienie si znaku
      Valadc = Getadc(2) * &H02         'Odczyt pooenia potencjometru zadajcego prdko obrotow
      Tmp0 = Ischarwaiting()            'Sprawdzenie czy USART odebra znak w buforze USART
    Loop Until Tmp0 = 1                 'Jeeli odebrano znak to opuszczenie ptli
    Tmp0 = Inkey()                      'i odbir kodu znaku z bufora USART do zmiennej
    If Portc.3 = 1 Then                 'Tryb test TEST nie jest wczony
        Print Chr(tmp0);                'odesanie odebranego znaku do terminala PC (echo)
    End If
    If Tmp0 <> 10 And Tmp0 <> 13 Then   'Kady znak inny ni CR jest
      Stmp = Stmp + Chr(tmp0)           '"doczany" do tymczasowej zmiennej acuchowej
    End If
    If Tmp0 = 27 Then                   'Jeeli otrzymano znak ESC
      Stmp = ""                         'Anulowanie polecenia
    End If
  Loop Until Tmp0 = 10                  'Uytkownik zatwierdzi polecenie znakiem CR
  If Portc.3 = 0 Then                   'Tryb test [TEST] jest wczony
    Call Demo_test                      'wykonanie kolejnego "kroku" trybu [TEST]
  Else
    Stptst = 0                          'Zerowanie zmiennej liczcej "kroki" trybu [TEST]
    Call Parse_order                    'Sprawdzenie poprawnoci polecenia i jego parametru i zamiana na wartoci numeryczne
  End If
  Prmstat = 0                           'Zerowanie zmiennej tymczasowej
  Select Case Order
    Case &H00 To &H05 : Single_cmd      'Interpretacja polece bez-parametrycznych [HELP][?][RUN][STOP][TEST][RST]
    Case &H06 : Prmstat.0 = Portc.4     '[CSM] Zapamitanie stanu, bitu [CSM]
                Call Set_parameter      'Interpretacja parametru [ON/OFF]
                Portc.4 = Prmstat.0     'Wczenie lub wyczenie [CSM]
    Case &H07 : Prmstat.0 = Portb.4     '[SLP] Zapamitanie stanu, bitu [!SLEEP]
                Call Set_parameter      'Interpretacja parametru [ON/OFF]
                Portb.4 = Prmstat.0     'Wczenie lub wyczenie [!SLEEP]
    Case &H08 : Prmstat.0 = Portb.3     '[ENB] Zapamitanie stanu, bitu [!ENABLE]
                Call Set_parameter      'Interpretacja parametru [ON/OFF]
                Portb.3 = Prmstat.0     'Wczenie lub wyczenie [!ENABLE]
    Case &H09 : Prmstat.0 = Ctrlstep.6  '[DIR] Zapamitanie stanu, bitu [DIR]
                Call Set_parameter      'Interpretacja parametru [CW/CCW]
                Ctrlstep.6 = Prmstat.0  'Tymczasowe zadanie kierunku obrotw [DIR]
    Case &H0A : Prmstat.0 = Ctrlstep.5  '[RES] Zapamitanie stanu, bitu MS1
                Prmstat.1 = Ctrlstep.4  'i MS2 rozdzielczoci krokowej
                Call Set_parameter      'Interpretacja parametru, tymczasowe ustawienie rozdzielczoci kroku [FS/HS/QS/ES]
    Case &H0B : Prmstat.0 = Portb.5     '[BST] Zapamitanie stanu, bitu [BOOST]
                Toggle Prmstat.0        'Negacja zapamitanego stanu
                Call Set_parameter      'Interpretacja parametru [ON/OFF]
                Toggle Prmstat.0        'Negacja zapamitanego lub zmodyfikowanego stanu
                Portb.5 = Prmstat.0     'Wczenie prdu nominalnego lub trzymania [BOOST]
    Case &HFF : Print Cmderr            'Wysanie komunikatu "bdne polecenie"
  End Select
Loop
End

'----------------------------------------------------------------------------------------
'Definicje procedur
'----------------------------------------------------------------------------------------
Sub Parse_order                         'Parsowanie polece, parametrw i zamiana ich na wartoci numeryczne
  Order = &HFE
  If Stmp <> "" Then
    Order = &HFF                        'Przypisanie staej bdne polecenie, nadpisywane gdy polecenie poprawne
    Param = &HFE                        'Przypisanie staej polecenie bez-parametryczny, nadpisywane gdy parametr poprawny
    Stmp = Trim(stmp)                   'Usunicie ewentualnych spacji z pocztku i koca acucha znakw
    Stmp = Ucase(stmp)                  'Zmiana znakw na wielkie
    Tmp0 = Instr(stmp , " ")            'Wyliczenie pozycji pierwszej moliwej spacji dla polecenia parametrycznego
    Cmd = Left(stmp , Tmp0)             'Zapamitanie polecenia
    Cmd = Trim(cmd)                     'Usunicie ewentualnych spacji z pocztku i koca zapamitanego polecenia
    If Tmp0 <> 0 Then                   'Wystpuje parametr
      Param = &HFF                      'Przypisanie staej bdny parametr
      Tmp0 = Len(stmp) - Tmp0           'Obliczenie dugoci parametru
      Prm = Right(stmp , Tmp0)          'Zapamitanie parametru
      Prm = Trim(prm)                   'Usunicie ewentualnych spacji z pocztku i koca zapamitanego parametru
      For Tmp0 = 0 To 7                 'Dla omiu moliwych parametrw...
        Stmp = Lookupstr(tmp0 , Cmdprm) 'Kolejne przypisania poprawnych parametrw tekstowych w celu porwnania
        Stmp = Trim(stmp)               '"Obcicie" spacji
        If Stmp = Prm Then              'Parametr zadany "zgadza" si z jednym z omiu moliwych parametrw
          Param = Tmp0                  'Przypisanie wartoci numerycznej parametru w celu pniejszej interpretacji
        End If
      Next Tmp0
    End If
    For Tmp0 = 0 To 11                  'Dla dwunastu moliwych polece...
      Stmp = Lookupstr(tmp0 , Drvcmd)   'Kolejne przypisania poprawnych polece tekstowych w celu porwnania
      If Stmp = Cmd Then                'Polecenie zadane "zgadza" si z jednym z dwunastu moliwych polece
        Order = Tmp0                    'Przypisanie wartoci numerycznej polecenia w celu pniejszej interpretacji
      End If
    Next Tmp0
  End If
End Sub

'----------------------------------------------------------------------------------------
Sub Single_cmd                          'Interpretacja polece bez-parametrycznych [HELP][?][RUN][STOP][TEST][RST]
  If Prm <> "" Then                     'Jeeli otrzymano parametr to
    Print Cmderr                        'wysanie komunikatu "bdne polecenie"
  Else
    Select Case Order
      Case &H00 : Call Print_help       '[HELP] Wysanie tekstu pomocy
      Case &H01 : Call Print_status     '[?] Wysanie status sterownika
      Case &H02 : Reset Portc.5         '[RUN] Wczenie obrotw
                  Tstdel = Valadc       'Warto opnienia
                  If Portc.4 = 1 Then   'Dla trybu zmiennej prdkoci w funkcji rozdzielczoci krokowej
                    Tmp0 = 8 \ Div      'Wyliczenie mnonika opnienia zalenie od aktualnej rozdzielczoci krokowej
                    Tstdel = Tstdel * Tmp0       'Opnienie mnoone przez 1, 2, 4, 8 odpowiednio dla 1/1, 1/2, 1,4, 1/8 kroku
                  End If
                  Compare1a = Tstdel    'Przypisanie czasu opnienia do rejestru porwnania OC1A
                  Enable Compare1a      'Wczenie obsugi przerwania od porwnania OC1A
                  Timer1 = 0            'Licznik liczy od zera
                  Start Timer1          'Wczenie timera1 (konieczne ze wzgldu na zatrzymywanie Timer1 w obsudze przerwania)
      Case &H03 : Set Portc.5           '[STOP] Zatrzymanie obrotw
      Case &H04 : Reset Portc.3         '[TEST] Wczenie sekwencyjnego testu demonstracyjnego
                  Prompt = Prmttst      'Ustawienie promptu dla trybu [TEST] ":"
      Case &H05 : Reset Portb.2         '[RST] Restart sekwencera sterownika
    End Select
  End If
End Sub

'----------------------------------------------------------------------------------------
Sub Demo_test                           'Sekwencja trybu testowo-demonstracyjnego [TEST]
  Prmstat = &HFE                        'Przypisanie staej rozkaz bez-parametryczny do zmiennej tymczasowej nadpisywane gdy parametr poprawny
  Select Case Stptst                    'Interpretacja kolejnych "krokw" sekwencji trybu [TEST]
    Case &H00 : Order = &H07            '[SLP] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H01          '[OFF] Przygotowanie do "Obudzenia" sterownika z trybu oszczdzania energji
    Case &H01 : Order = &H08            '[ENB] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H00          '[ON] Przygotowanie do wczenia mostkw mocy sterownika
    Case &H02 : Order = &H09            '[DIR] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H02          '[CW] Przygotowanie do ustawienie kierunku obrotw silnika na [CW]
    Case &H03 : Order = &H05            '[RST] Wykonanie nastpi w ptli gwnej programu
    Case &H04 : Order = &H0B            '[BST] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H00          '[ON ] Przygotowanie do wczenia prdu nominalnego uzwoje silnika
    Case &H05 : Order = &H02            '[RUN] Przygotowanie do wczenia obrotw, wykonanie nastpi w ptli gwnej programu
    Case &H06 To &H09 : Order = &H0A    '[RES] Przygotowanie do zmiany rozdzielczoci krokowej, wykonanie nastpi w ptli gwnej programu
                        Prmstat = Stptst - 2       'w kolejnoci: [FS,HS,QS,ES]
    Case &H0A : Order = &H09            '[DIR] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H03          '[CCW] Przygotowanie do zmiany kierunku obrotw na [CCW]
    Case &H0B To &H0E : Order = &H0A    '[RES] Przygotowanie do zmiany rozdzielczoci krokowej, wykonanie nastpi w ptli gwnej programu
                        Prmstat = Stptst - 7       'w kolejnoci: [FS,HS,QS,ES]
    Case &H0F : Order = &H03            '[STOP] Przygotowanie do wyczenia obrotw, wykonanie nastpi w ptli gwnej programu
    Case &H10 : Order = &H0B            '[BST] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H01          '[OFF] Przygotowanie do wczenia prdu trzymania uzwoje silnika
    Case &H11 : Order = &H08            '[ENB] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H01          '[OFF] Przygotowanie do wyczenia mostkw mocy sterownika
    Case &H12 : Order = &H07            '[SLP] Wykonanie nastpi w ptli gwnej programu
                Prmstat = &H00          '[ON] Przygotowanie do przejcia sterownika w tryb oszczdzania energji
                Set Portc.3             'Wyjcie z trybu [TEST], powrt do interpretacji polece sterujcych
                Prompt = Prmt           'Ustawienie Promptu domylnego ">"
  End Select
  Print Chr(&H10) ; Chr(&H02) ; Lookupstr(order , Drvcmd) ; Chr(&H10) ; Chr(&H07);       'Wysanie aktualnego rozkazu "kroku" sekwencji [TEST]
  If Prmstat <> &HFE Then               'Jeeli rozkaz nie jest bez-parametryczny
    Param = Prmstat                     'to jego interpretacja nastpi w ptli gwnej programu
    Print " " ; Lookupstr(param , Cmdprm)       'wysanie aktualnego parametru "kroku" sekwencji [TEST]
  Else
    Print                               'Wysanie znakw CR+LF
  End If
  Incr Stptst                           'Inkrementacja zmiennej wyliczajcej kolejne "kroki" trybu [TEST]
End Sub

'----------------------------------------------------------------------------------------
Sub Set_parameter                       'Interpretacja parametrw polece
  Tmp0 = Lookup(order , Expprm)         'W zalenoci od polecenia przypisanie staej pierwszego indeksu zbioru parametrw dozwolonych
  If Param = &HFE Then                  'Gdy nie podano parametru
    If Tmp0 = 5 Then                    'Odebrano polecenie zmiany rozdzielczoci kroku
      Tmp0 = Prmstat + 4                'Wyliczenie indeksu aktualnego "stanu polecenia" zapamitanego w Prmstat
    Else                                'Odebrano polecenie typu wcz/wycz lub zmiany kierunku
      If Prmstat.0 = 0 Then
        Decr Tmp0                       'wyliczenie indeksu aktualnego "stanu polecenia" zapamitanego w Prmstat
      End If
    End If
    Print " " ; Lookupstr(tmp0 , Cmdprm)       'Wysanie aktualnego stanu polecenia
  Else
    Select Case Tmp0                    'Odebrano parametr polecenia
      Case &H01 : If Param <= &H01 Then 'Dla polece z poprawnym parametrem ON/OFF
                    Prmstat = Param     'Warto 0 lub 1 zalenie od otrzymanego parametru
                  Else
                    Param = &HFF        'Ustawienie flagi bdny parametr
                  End If
      Case &H03 : If Param >= &H02 And Param <= &H03 Then       'Polecenia zmiany kierunku obrotw z poprawnym parametrem CW/CCW
                    Prmstat = Param And &H01       'Warto 0 lub 1 zalenie od otrzymanego parametru
                  Else
                    Param = &HFF        'Ustawienie flagi bdu
                  End If
      Case &H05 : If Param >= &H04 And Param <= &H07 Then       'Polecenia zmiany rozdzielczoci kroku z poprawnym parametrem FS/HS/QS/ES
                    Tmp0 = Param - 4    'Wyliczenie indeksu tablicowej staej rozdzielczoci kroku
                    Prmstat = Lookup(tmp0 , Rstep)       'Odczyt staej rozdzielczoci kroku wedug indeksu
                    Prmstat.6 = Ctrlstep.6       'Przepisanie bitu aktualnego kierunku obrotw
                    Ctrlstep = Prmstat  'Zadanie rozdzielczoci kroku
                  Else
                    Param = &HFF        'Ustawienie flagi bdny parametr
                  End If
    End Select
    If Param = &HFF Then                'Otrzymano bdny parametr
      Print Prmerr                      'Wysanie komunikatu "bdny parametr"
    End If
  End If
End Sub

'----------------------------------------------------------------------------------------
Sub Print_help                          'Wysanie tekstu pomocy
  Print Vprog                           'Nazwa i wersja programu
  Print "Tester Command:"               'Polecenia, parametry testera...
  Print Chr(&H10) ; Chr(&H02) ; " HELP" ; Chr(&H10) ; Chr(&H07) ; " - Print this text"
  Print Chr(&H10) ; Chr(&H02) ; " ?" ; Chr(&H10) ; Chr(&H07) ; " - Print driver status"
  Print Chr(&H10) ; Chr(&H02) ; " CSM ON / OFF" ; Chr(&H10) ; Chr(&H07) ; " - Constant rpm in microstepping resolution"
  Print Chr(&H10) ; Chr(&H02) ; " RUN" ; Chr(&H10) ; Chr(&H07) ; " - Start revolution"
  Print Chr(&H10) ; Chr(&H02) ; " STOP" ; Chr(&H10) ; Chr(&H07) ; " - Stop revolution"
  Print Chr(&H10) ; Chr(&H02) ; " TEST" ; Chr(&H10) ; Chr(&H07) ; " - Run demo test"
  Print "Driwer Command:"               'Polecenia, parametry dla sterownika...
  Print Chr(&H10) ; Chr(&H02) ; " RST" ; Chr(&H10) ; Chr(&H07) ; " - Reset driver"
  Print Chr(&H10) ; Chr(&H02) ; " SLP ON / OFF" ; Chr(&H10) ; Chr(&H07) ; " - Sleep mode control"
  Print Chr(&H10) ; Chr(&H02) ; " ENB ON / OFF" ; Chr(&H10) ; Chr(&H07) ; " - Output DMOS driver control"
  Print Chr(&H10) ; Chr(&H02) ; " DIR CW / CCW" ; Chr(&H10) ; Chr(&H07) ; " - Change direction"
  Print Chr(&H10) ; Chr(&H02) ; " RES FS / HS / QS / ES" ; Chr(&H10) ; Chr(&H07) ; " - Change microstepping resolution"
  Print Chr(&H10) ; Chr(&H02) ; " BST ON / OFF" ; Chr(&H10) ; Chr(&H07) ; " - Torque/holding current"
End Sub

'----------------------------------------------------------------------------------------
Sub Print_status                        'Wysanie statusu urzdzenia
  For Tmp0 = 6 To 11                    'Dla szeciu monitorowanych polece...
    Print Chr(&H10) ; Chr(&H02) ; " " ; Lookupstr(tmp0 , Drvcmd) ; " ";       'Wysanie kolejno ich nazw
  Next Tmp0
  Print Chr(&H10) ; Chr(&H07) ;
  Prmstat.0 = Ctrlstep.5                '[MS1] Zapamitanie, posortowanie aktualnych stanw polece dla...
  Prmstat.1 = Ctrlstep.4                '[MS2] ...Rozdzielczoci krokowej
  Prmstat.2 = Portc.4                   '[CSM] Trybu prdkoci
  Prmstat.3 = Portb.4                   '[SLP] Stanu oszczdzania energii
  Prmstat.4 = Portb.3                   '[ENB] Wczenia, wyczenia mostkw wyjciowych sterownika
  Prmstat.5 = Ctrlstep.6                '[DIR] Kierunku obrotw
  Prmstat.7 = Not Portb.5               '[BST] Zaczonego prdu trzymania, roboczego
  Print
  For Tmp0 = 2 To 7                     'Dla piciu "pierwszych" wedug wysanych wczeniej nazw polece...
    Index = 0                           'przypisanie staej pierwszego indeksu zbioru parametrw
    If Tmp0 = 5 Then                    '[DIR] Stan polecenia kierunku obrotw
      Index = 2                         'przypisanie staej indeksu parametru [CW]
    End If
    If Tmp0 = 6 Then                    '[RES] Polecenie zmiany rozdzielczoci krokowej
      Param = Prmstat And &H03          '"Wyuskanie" dwch bitw wyznaczajcych rozdzielczo krokow
      Index = Param + 4                 'Wyznaczenie indeksu ustawionej rozdzielczoci przez dodanie offsetu [FS,HS,QS,ES]
    Else                                'Dla polece dwu-stanowych [ON,OFF]
      If Prmstat.tmp0 = 1 Then          'Polecenie wyczone [OFF] lub kierunek ustawiony na [CCW]
        Incr Index                      'Zwikszenie indeksu o jeden
      End If
    End If
    Print " " ; Lookupstr(index , Cmdprm) ; " ";       'Kolejne, wedug indeksu, wysanie pojedynczych "statusw" polece
  Next Tmp0
  Tmp0 = 2                              'Przypisanie staej indeksu polecenia [RUN]
  If Portc.5 = 1 Then                   'Silnik aktualnie zatrzymany
    Tmp0 = 3                            'Przypisanie staej indeksu polecenia [STOP]
  End If
  Print " " ; Chr(&H10) ; Chr(&H02) ; Lookupstr(tmp0 , Drvcmd)       'Wysanie informacji o wczeniu, wyczeniu obrotw
End Sub

'----------------------------------------------------------------------------------------
'Obsuga przerwa
'----------------------------------------------------------------------------------------
Home_synhro:                            'Przerwanie od zbocza opadajcego na wejciu HOME
  Clk = 0                               'Reset licznika sekwencji (synchronizacja)
Return

'----------------------------------------------------------------------------------------
Step_sequnce:                           'Przerwanie od porwnania zawartoci licznika z rejestrem.
  If Pinb.1 = 0 Then                    'Instrukcje wykonywane w "parzystym" przerwaniu
    Compare1a = Tstdel                  'Ustawienie "interwau" po jakim nastpi kolejna obsuga przerwania
    Tmp = Ctrlstep And &H0F             '"Wyuskanie" wartoci co ile zmian Clk wystpuje impuls zegarowy na wyjciu STEP
    If Tmp > Div Then                   'Zadana rozdzielczo kroku jest mniejsza od ustawionej
      Chprm = Tmp - Div                 'Wyliczenie rnicy "zmiany", moliwe wartoci &b: 000, 001, 010, 011, 100, 110, 111
    Else                                'Gdy zadana rozdzielczo kroku jest wiksza od ustawionej
      Chprm = Div - Tmp                 'Wyliczenie rnicy "zmiany" moliwe wartoci &b: 000, 001, 010, 011, 100, 110, 111
    End If
    Chprm = Chprm And Clk               'Iloczyn logiczny zmiennej Clk z "rnic zmiany", istotne trzy najmniej znaczace bity CLK
    If Chprm = 0 Then                   'Zmiana rozdzielczoci dozwolona i nie spowoduje zmiany prdu w uzwojeniach silnika przy przelczeniu
      Portd.3 = Ctrlstep.5              '[MS1] ustawienie modszego bitu rozdzielczoci kroku
      Portd.4 = Ctrlstep.4              '[MS2] ustawienie starszego bitu rozdzielczoci kroku
      Portd.5 = Ctrlstep.6              '[DIR] ustawienie bitu kierunku obrotw
      Div = Tmp                         'Zapamitanie ustawionej rozdzielczoci kroku
    End If
    Chprm = Clk Mod Div                 'Podzia zmiennej zegarowej w zalenoci od ustawionej rozdzielczoci krokowej
    If Chprm = 0 Then                   'Co 1, 2, 4, 8, zmian zmiennej zegarowej odpowiednio dla 1/8, 1/4, 1/2, 1/1 kroku
      Set Portb.0                       '[STEP] Pocztek wysokiego impulsu zegarowego (wykonanie kroku/mikrokroku)
    End If
    If Portd.5 = 0 Then                 'Zalenie od ustawionego kierunku obrotw:
      Incr Clk                          'Zwikszenie licznika sekwencji
    Else
      Decr Clk                          'Zmniejszenie licznika sekwencji
    End If
  Else                                  'Instrukcje wykonywane "nieparzystym" przerwaniu
    Compare1a = Tstdel                  'Ustawienie "interwau" po jakim nastpi kolejna obsuga przerwania
    Tstdel = Valadc                     ' + &H06              'Zabezpieczenie przed zbyt czstym wykonaniem prezerwania gdy Valadc wynosi mniej ni cztery
    If Portc.4 = 1 Then                 '[CSM OFF] Wyczona staa prdko obrotowa w funkcji rozdzielczoci krokowej
      Tmp = &H08 \ Div                  'Wyliczenie mnonika opnienia zalenie od aktualnej rozdzielczoci krokowej
      Tstdel = Tstdel * Tmp             'Opnienie mnoone przez 1, 2, 4, 8 odpowiednio dla 1/1, 1/2, 1,4, 1/8 kroku
    End If
    Reset Portb.0                       '[STEP] Koniec wysokiego impulsu zegarowego
    If Portc.5 = 1 Then                 '[STOP] Zatrzymano obroty
      Stop Timer1                       'Zatrzymanie Timera1 (celowo zamiast "Disable OC1A" aby nie wystpowa przebieg na PB1)
    End If
  End If
Return                                  'Powrt z obsugi przerwania

'----------------------------------------------------------------------------------------
Rstep:                                  'Stae rozdzielczoci kroku bit 4:[MS2], bit 5:[MS1], bity 0..3:[Dzielnik modulo] zmiennej zegarowej CLK
  Data &B00001000                       'Rozdzielczo 1/1 kroku
  Data &B00100100                       'Rozdzielczo 1/2 kroku
  Data &B00010010                       'Rozdzielczo 1/4 kroku
  Data &B00110001                       'Rozdzielczo 1/8 kroku
Drvcmd:                                 'Stae tekstowe polece...
  Data "HELP" , "?" , "RUN" , "STOP" , "TEST" , "RST"
  Data "CSM" , "SLP" , "ENB" , "DIR" , "RES" , "BST"
Cmdprm:                                 'Stae tekstowe parametrw polece...
  Data "ON " , "OFF" , "CW " , "CCW" , "FS " , "HS " , "QS " , "ES "
Expprm:                                 'Stae wyznaczajce pierwszy indeks zbioru
  Data &HFE , &HFE , &HFE , &HFE , &HFE , &HFE       'parametrw dozwolonych dla polecenia (&HFE brak parametru)...
  Data &H01 , &H01 , &H01 , &H03 , &H05 , &H01

'ENDE------------------------------------------------------------------------------------